Index: issm/trunk/src/c/DataSet/DataSet.cpp
===================================================================
--- issm/trunk/src/c/DataSet/DataSet.cpp	(revision 4054)
+++ issm/trunk/src/c/DataSet/DataSet.cpp	(revision 4055)
@@ -684,29 +684,4 @@
 	xfree((void**)&truedofs);
 	xfree((void**)&alltruedofs);
-
-}
-/*}}}*/
-/*FUNCTION DataSet::FieldExtrude{{{1*/
-void  DataSet::FieldExtrude(Vec field,double* field_serial,char* field_name, int collapse){
-
-	vector<Object*>::iterator object;
-	Penta* penta=NULL;
-	Node*  node=NULL;
-
-	for ( object=objects.begin() ; object < objects.end(); object++ ){
-
-		if((*object)->Enum()==PentaEnum){
-
-			penta=(Penta*)(*object);
-			penta->FieldExtrude(field,field_serial,field_name,collapse);
-
-		}
-		if((*object)->Enum()==NodeEnum){
-
-			node=(Node*)(*object);
-			node->FieldExtrude(field,field_serial,field_name);
-
-		}
-	}
 
 }
Index: issm/trunk/src/c/DataSet/DataSet.h
===================================================================
--- issm/trunk/src/c/DataSet/DataSet.h	(revision 4054)
+++ issm/trunk/src/c/DataSet/DataSet.h	(revision 4055)
@@ -80,5 +80,4 @@
 		void  InputExtrude(int enum_type);
 		int   DeleteObject(Object* object);
-		void  FieldExtrude(Vec field,double* field_serial,char* field_name, int collapse);
 		void  OutputRifts(Vec riftproperties);
 		/*}}}*/
Index: issm/trunk/src/c/EnumDefinitions/EnumAsString.cpp
===================================================================
--- issm/trunk/src/c/EnumDefinitions/EnumAsString.cpp	(revision 4054)
+++ issm/trunk/src/c/EnumDefinitions/EnumAsString.cpp	(revision 4055)
@@ -26,7 +26,4 @@
 		case VerticesEnum : return "Vertices";
 		case SolutionTypeEnum : return "SolutionType";
-		case DiagnosticSolutionEnum : return "DiagnosticSolution";
-		case SurfaceSlopeSolutionEnum : return "SurfaceSlopeSolution";
-		case BedSlopeSolutionEnum : return "BedSlopeSolution";
 		case AnalysisTypeEnum : return "AnalysisType";
 		case SubAnalysisTypeEnum : return "SubAnalysisType";
@@ -46,7 +43,8 @@
 		case InverseAnalysisEnum : return "InverseAnalysis";
 		case ThermalAnalysisEnum : return "ThermalAnalysis";
-		case TransientAnalysisEnum : return "TransientAnalysis";
+		case Transient2DAnalysisEnum : return "Transient2DAnalysis";
+		case Transient3DAnalysisEnum : return "Transient3DAnalysis";
 		case SteadyAnalysisEnum : return "SteadyAnalysis";
-		case SlopeComputeAnalysisEnum : return "SlopeComputeAnalysis";
+		case SlopeAnalysisEnum : return "SlopeAnalysis";
 		case BedSlopeXAnalysisEnum : return "BedSlopeXAnalysis";
 		case BedSlopeYAnalysisEnum : return "BedSlopeYAnalysis";
@@ -220,4 +218,7 @@
 		case StringExternalResultEnum : return "StringExternalResult";
 		case JEnum : return "J";
+		case RelativeEnum : return "Relative";
+		case ResidualEnum : return "Residual";
+		case AbsoluteEnum : return "Absolute";
 		case BetaEnum : return "Beta";
 		case CmGradientEnum : return "CmGradient";
@@ -225,5 +226,7 @@
 		case CmMaxEnum : return "CmMax";
 		case CmMinEnum : return "CmMin";
+		case AdjointEnum : return "Adjoint";
 		case GradientEnum : return "Gradient";
+		case OldGradientEnum : return "OldGradient";
 		case ConnectivityEnum : return "Connectivity";
 		case ControlParameterEnum : return "ControlParameter";
Index: issm/trunk/src/c/EnumDefinitions/EnumDefinitions.h
===================================================================
--- issm/trunk/src/c/EnumDefinitions/EnumDefinitions.h	(revision 4054)
+++ issm/trunk/src/c/EnumDefinitions/EnumDefinitions.h	(revision 4055)
@@ -22,7 +22,4 @@
 	/*Solution types {{{1 */
 	SolutionTypeEnum,
-	DiagnosticSolutionEnum,
-	SurfaceSlopeSolutionEnum,
-	BedSlopeSolutionEnum,
 	/*}}}*/
 	/*Analysis types {{{1 */
@@ -48,8 +45,9 @@
 	ThermalAnalysisEnum,
 	//transient
-	TransientAnalysisEnum,
+	Transient2DAnalysisEnum,
+	Transient3DAnalysisEnum,
 	SteadyAnalysisEnum,
 	//slope
-	SlopeComputeAnalysisEnum,
+	SlopeAnalysisEnum,
 	BedSlopeXAnalysisEnum,
 	BedSlopeYAnalysisEnum,
@@ -254,4 +252,9 @@
 	JEnum,
 	/*}}}*/
+	/*Convergence{{{1*/
+	RelativeEnum,
+	ResidualEnum,
+	AbsoluteEnum,
+	/*}}}*/
 	/*Parameters{{{1*/
 	BetaEnum,
@@ -260,5 +263,7 @@
 	CmMaxEnum,
 	CmMinEnum,
+	AdjointEnum,
 	GradientEnum,
+	OldGradientEnum,
 	ConnectivityEnum,
 	ControlParameterEnum,
Index: issm/trunk/src/c/EnumDefinitions/StringAsEnum.cpp
===================================================================
--- issm/trunk/src/c/EnumDefinitions/StringAsEnum.cpp	(revision 4054)
+++ issm/trunk/src/c/EnumDefinitions/StringAsEnum.cpp	(revision 4055)
@@ -24,7 +24,4 @@
 	else if (strcmp(name,"Vertices")==0) return VerticesEnum;
 	else if (strcmp(name,"SolutionType")==0) return SolutionTypeEnum;
-	else if (strcmp(name,"DiagnosticSolution")==0) return DiagnosticSolutionEnum;
-	else if (strcmp(name,"SurfaceSlopeSolution")==0) return SurfaceSlopeSolutionEnum;
-	else if (strcmp(name,"BedSlopeSolution")==0) return BedSlopeSolutionEnum;
 	else if (strcmp(name,"AnalysisType")==0) return AnalysisTypeEnum;
 	else if (strcmp(name,"SubAnalysisType")==0) return SubAnalysisTypeEnum;
@@ -44,7 +41,8 @@
 	else if (strcmp(name,"InverseAnalysis")==0) return InverseAnalysisEnum;
 	else if (strcmp(name,"ThermalAnalysis")==0) return ThermalAnalysisEnum;
-	else if (strcmp(name,"TransientAnalysis")==0) return TransientAnalysisEnum;
+	else if (strcmp(name,"Transient2DAnalysis")==0) return Transient2DAnalysisEnum;
+	else if (strcmp(name,"Transient3DAnalysis")==0) return Transient3DAnalysisEnum;
 	else if (strcmp(name,"SteadyAnalysis")==0) return SteadyAnalysisEnum;
-	else if (strcmp(name,"SlopeComputeAnalysis")==0) return SlopeComputeAnalysisEnum;
+	else if (strcmp(name,"SlopeAnalysis")==0) return SlopeAnalysisEnum;
 	else if (strcmp(name,"BedSlopeXAnalysis")==0) return BedSlopeXAnalysisEnum;
 	else if (strcmp(name,"BedSlopeYAnalysis")==0) return BedSlopeYAnalysisEnum;
@@ -218,4 +216,7 @@
 	else if (strcmp(name,"StringExternalResult")==0) return StringExternalResultEnum;
 	else if (strcmp(name,"J")==0) return JEnum;
+	else if (strcmp(name,"Relative")==0) return RelativeEnum;
+	else if (strcmp(name,"Residual")==0) return ResidualEnum;
+	else if (strcmp(name,"Absolute")==0) return AbsoluteEnum;
 	else if (strcmp(name,"Beta")==0) return BetaEnum;
 	else if (strcmp(name,"CmGradient")==0) return CmGradientEnum;
@@ -223,5 +224,7 @@
 	else if (strcmp(name,"CmMax")==0) return CmMaxEnum;
 	else if (strcmp(name,"CmMin")==0) return CmMinEnum;
+	else if (strcmp(name,"Adjoint")==0) return AdjointEnum;
 	else if (strcmp(name,"Gradient")==0) return GradientEnum;
+	else if (strcmp(name,"OldGradient")==0) return OldGradientEnum;
 	else if (strcmp(name,"Connectivity")==0) return ConnectivityEnum;
 	else if (strcmp(name,"ControlParameter")==0) return ControlParameterEnum;
Index: issm/trunk/src/c/Makefile.am
===================================================================
--- issm/trunk/src/c/Makefile.am	(revision 4054)
+++ issm/trunk/src/c/Makefile.am	(revision 4055)
@@ -510,8 +510,10 @@
 					./modules/DepthAverageInputx/DepthAverageInputx.cpp\
 					./modules/DepthAverageInputx/DepthAverageInputx.h\
-					./modules/FieldExtrudex/FieldExtrudex.cpp\
-					./modules/FieldExtrudex/FieldExtrudex.h\
+					./modules/VecExtrudex/VecExtrudex.cpp\
+					./modules/VecExtrudex/VecExtrudex.h\
 					./modules/InputToResultx/InputToResultx.cpp\
 					./modules/InputToResultx/InputToResultx.h\
+					./modules/InputConvergencex/InputConvergencex.cpp\
+					./modules/InputConvergencex/InputConvergencex.h\
 					./modules/ExtrudeInputx/ExtrudeInputx.cpp\
 					./modules/ExtrudeInputx/ExtrudeInputx.h\
@@ -1014,8 +1016,10 @@
 					./modules/DepthAverageInputx/DepthAverageInputx.cpp\
 					./modules/DepthAverageInputx/DepthAverageInputx.h\
-					./modules/FieldExtrudex/FieldExtrudex.cpp\
-					./modules/FieldExtrudex/FieldExtrudex.h\
+					./modules/VecExtrudex/VecExtrudex.cpp\
+					./modules/VecExtrudex/VecExtrudex.h\
 					./modules/InputToResultx/InputToResultx.cpp\
 					./modules/InputToResultx/InputToResultx.h\
+					./modules/InputConvergencex/InputConvergencex.cpp\
+					./modules/InputConvergencex/InputConvergencex.h\
 					./modules/ExtrudeInputx/ExtrudeInputx.cpp\
 					./modules/ExtrudeInputx/ExtrudeInputx.h\
@@ -1030,5 +1034,6 @@
 					./solutions/controlrestart.cpp\
 					./solutions/objectivefunctionC.cpp\
-					./solutions/gradjcompute_core.cpp\
+					./solutions/gradient_core.cpp\
+					./solutions/adjoint_core.cpp\
 					./solutions/prognostic_core.cpp\
 					./solutions/prognostic2_core.cpp\
@@ -1040,7 +1045,6 @@
 					./solutions/bedslope.cpp\
 					./solutions/bedslope_core.cpp\
-					./solutions/transient_core.cpp\
-					./solutions/transient_core_2d.cpp\
-					./solutions/transient_core_3d.cpp\
+					./solutions/transient2d_core.cpp\
+					./solutions/transient3d_core.cpp\
 					./solutions/steadystate_core.cpp\
 					./solutions/ResetBoundaryConditions.cpp\
@@ -1058,5 +1062,5 @@
 bin_PROGRAMS = 
 else 
-bin_PROGRAMS = DiagnosticSolution.exe ThermalSolution.exe PrognosticSolution.exe Prognostic2Solution.exe BalancedthicknessSolution.exe Balancedthickness2Solution.exe BalancedvelocitiesSolution.exe TransientSolution.exe SteadystateSolution.exe SurfaceSlopeSolution.exe BedSlopeSolution.exe 
+bin_PROGRAMS = DiagnosticSolution.exe ThermalSolution.exe PrognosticSolution.exe Prognostic2Solution.exe BalancedthicknessSolution.exe Balancedthickness2Solution.exe BalancedvelocitiesSolution.exe Transient2DSolution.exe Transient23Solution.exe SteadystateSolution.exe SurfaceSlopeSolution.exe BedSlopeSolution.exe 
 endif
 
@@ -1093,4 +1097,7 @@
 BedSlopeSolution_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
 
-TransientSolution_exe_SOURCES = solutions/transient.cpp
-TransientSolution_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
+Transient2DSolution_exe_SOURCES = solutions/transient2d.cpp
+Transient2DSolution_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
+
+Transient3DSolution_exe_SOURCES = solutions/transient3d.cpp
+Transient3DSolution_exe_CXXFLAGS= -fPIC -D_PARALLEL_ 
Index: issm/trunk/src/c/modules/CostFunctionx/CostFunctionx.h
===================================================================
--- issm/trunk/src/c/modules/CostFunctionx/CostFunctionx.h	(revision 4054)
+++ issm/trunk/src/c/modules/CostFunctionx/CostFunctionx.h	(revision 4055)
@@ -10,6 +10,5 @@
 
 /* local prototypes: */
-void CostFunctionx( double* pJ, DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters, 
-			int analysis_type,int sub_analysis_type);
+void CostFunctionx( double* pJ, DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters);
 
 #endif  /* _MISFITX_H */
Index: issm/trunk/src/c/modules/DepthAverageInputx/DepthAverageInputx.cpp
===================================================================
--- issm/trunk/src/c/modules/DepthAverageInputx/DepthAverageInputx.cpp	(revision 4054)
+++ issm/trunk/src/c/modules/DepthAverageInputx/DepthAverageInputx.cpp	(revision 4055)
@@ -10,5 +10,5 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void DepthAverageInputx( DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters,int enum_type){
+void DepthAverageInputx( DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters,int enum_type,int average_enum_type){
 	
 	/*Intermediary*/
@@ -22,9 +22,8 @@
 	for (i=0;i<elements->Size();i++){
 		element=(Element*)elements->GetObjectByOffset(i);
-		element->DepthAverageInputAtBase(enum_type);
+		element->DepthAverageInputAtBase(enum_type,average_enum_type);
 	}
 
 	/*Then extrude vertically the new inputs*/
-	elements->InputExtrude(enum_type);
-
+	elements->InputExtrude(average_enum_type);
 }
Index: issm/trunk/src/c/modules/DepthAverageInputx/DepthAverageInputx.h
===================================================================
--- issm/trunk/src/c/modules/DepthAverageInputx/DepthAverageInputx.h	(revision 4054)
+++ issm/trunk/src/c/modules/DepthAverageInputx/DepthAverageInputx.h	(revision 4055)
@@ -9,5 +9,5 @@
 
 /* local prototypes: */
-void DepthAverageInputx( DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters,int enum_type);
+void DepthAverageInputx( DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters,int enum_type,int average_enum_type);
 
 #endif  /* _DEPTHAVERAGEINPUTX_H */
Index: issm/trunk/src/c/modules/Dux/Dux.h
===================================================================
--- issm/trunk/src/c/modules/Dux/Dux.h	(revision 4054)
+++ issm/trunk/src/c/modules/Dux/Dux.h	(revision 4055)
@@ -10,7 +10,5 @@
 
 /* local prototypes: */
-void Dux( Vec* pdu_g, DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters, 
-			int analysis_type,int sub_analysis_type);
-
+void Dux( Vec* pdu_g, DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters);
 #endif  /* _DUX_H */
 
Index: issm/trunk/src/c/modules/FieldDepthAveragex/FieldDepthAveragex.cpp
===================================================================
--- issm/trunk/src/c/modules/FieldDepthAveragex/FieldDepthAveragex.cpp	(revision 4054)
+++ issm/trunk/src/c/modules/FieldDepthAveragex/FieldDepthAveragex.cpp	(revision 4055)
@@ -43,5 +43,8 @@
 
 	/*Extrude field to all nodes: */
-	nodes->FieldExtrude(field,field_serial,fieldname,0);
+	for(i=0;i<nodes->Size();i++){
+		node=(Node*)nodes->GetObjectByOffset(i);
+		node->VecExtrude(field,field_serial);
+	}
 
 	/*Assemble vector: */
Index: issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.h
===================================================================
--- issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.h	(revision 4054)
+++ issm/trunk/src/c/modules/GetSolutionFromInputsx/GetSolutionFromInputsx.h	(revision 4055)
@@ -10,5 +10,5 @@
 
 /* local prototypes: */
-void GetSolutionFromInputsx( Vec* psolution, DataSet* elements,DataSet* nodes, DataSet* vertices,DataSet* loads, DataSet* materials,  Parameters* parameters, int analysis_type, int sub_analysis_type);
+void GetSolutionFromInputsx( Vec* psolution, DataSet* elements,DataSet* nodes, DataSet* vertices,DataSet* loads, DataSet* materials,  Parameters* parameters);
 
 #endif  /* _GETSOLUTIONFROMINPUTSXX_H */
Index: issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp
===================================================================
--- issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp	(revision 4054)
+++ issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.cpp	(revision 4055)
@@ -38,2 +38,20 @@
 
 }
+
+void GetVectorFromInputsx( double* pvector, DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters, int NameEnum, int TypeEnum){
+	
+	/*output: */
+	double* vector=NULL;
+	
+	/*intermediary: */
+	Vec vec_vector=NULL;
+
+	GetVectorFromInputsx( &vec_vector, elements,nodes, vertices, loads, materials, parameters, NameEnum, TypeEnum);
+	VecToMPISerial(&vector,vec_vector);
+
+	/*Free ressources:*/
+	VecFree(&vec_vector);
+
+	/*Assign output pointers:*/
+	*pvector=vector;
+}
Index: issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.h
===================================================================
--- issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.h	(revision 4054)
+++ issm/trunk/src/c/modules/GetVectorFromInputsx/GetVectorFromInputsx.h	(revision 4055)
@@ -10,4 +10,5 @@
 /* local prototypes: */
 void	GetVectorFromInputsx( Vec* pvector, DataSet* elements,DataSet* nodes, DataSet* vertices,DataSet* loads, DataSet* materials,  Parameters* parameters,int NameEnum,int TypeEnum);
+void	GetVectorFromInputsx( double* pvector, DataSet* elements,DataSet* nodes, DataSet* vertices,DataSet* loads, DataSet* materials,  Parameters* parameters,int NameEnum,int TypeEnum);
 
 #endif  /* _GETVECTORFROMINPUTSXX_H */
Index: issm/trunk/src/c/modules/Gradjx/Gradjx.cpp
===================================================================
--- issm/trunk/src/c/modules/Gradjx/Gradjx.cpp	(revision 4054)
+++ issm/trunk/src/c/modules/Gradjx/Gradjx.cpp	(revision 4055)
@@ -10,10 +10,11 @@
 #include "../../EnumDefinitions/EnumDefinitions.h"
 
-void Gradjx( DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters,int control_type){
+void Gradjx( Vec* pgradient, DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials, Parameters* parameters,int control_type){
 
 	int i;
 	int dim;
-
-
+	int numberofvertices;
+	Vec gradient=NULL;
+	
 	/*First, get elements and loads configured: */
 	elements->  Configure(elements,loads, nodes,vertices, materials,parameters);
@@ -23,13 +24,20 @@
 	/*retrieve some parameters: */
 	parameters->FindParam(&dim,DimEnum);
+	parameters->FindParam(&numberofvertices,NumberOfVerticesEnum);
 
 	/*Compute gradients: */
 	for (i=0;i<elements->Size();i++){
 		Element* element=(Element*)elements->GetObjectByOffset(i);
-		element->Gradj(control_type);
+		element->Gradj(gradient,control_type);
 	}
 
+	/*Assemble vector: */
+	VecAssemblyBegin(gradient);
+	VecAssemblyEnd(gradient);
+
 	/*Extrude if needed: */
-	if(dim==3) ExtrudeInputx( elements,nodes, vertices, loads, materials, parameters,GradientEnum);
+	if(dim==3) VecExtrudex(gradient, elements,nodes, vertices, loads, materials, parameters,0);
 
+	/*Assign output pointers: */
+	*pgradient=gradient;
 }
Index: issm/trunk/src/c/modules/Gradjx/Gradjx.h
===================================================================
--- issm/trunk/src/c/modules/Gradjx/Gradjx.h	(revision 4054)
+++ issm/trunk/src/c/modules/Gradjx/Gradjx.h	(revision 4055)
@@ -10,5 +10,5 @@
 
 /* local prototypes: */
-void Gradjx( DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials,  Parameters* parameters, int control_type);
+void Gradjx(Vec* pgrad_g, DataSet* elements,DataSet* nodes, DataSet* vertices, DataSet* loads, DataSet* materials,  Parameters* parameters, int control_type);
 
 #endif  /* _GRADJX_H */
Index: issm/trunk/src/c/modules/InputConvergencex/InputConvergencex.cpp
===================================================================
--- issm/trunk/src/c/modules/InputConvergencex/InputConvergencex.cpp	(revision 4055)
+++ issm/trunk/src/c/modules/InputConvergencex/InputConvergencex.cpp	(revision 4055)
@@ -0,0 +1,58 @@
+/*!\file InputConvergencex
+ */
+
+#include "./InputConvergencex.h"
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../toolkits/toolkits.h"
+#include "../../EnumDefinitions/EnumDefinitions.h"
+
+int InputConvergencex(DataSet* elements,DataSet* nodes,DataSet* vertices,DataSet* loads,DataSet* materials,Parameters* parameters,int enums, int num_enums, int criterionenums, double* criterionvalues,int num_criterionenums){
+
+	/*intermediary:*/
+	int         i;
+	int         converged = 1;
+	int         node_converged=1;
+	double     *eps       = NULL;
+	extern int  my_rank;
+	int         rank_allowed;
+
+	/*First, configure our datasets: */
+	elements->Configure(elements,loads, nodes,vertices, materials,parameters);
+	nodes->     Configure(elements,loads, nodes,vertices, materials,parameters);
+	loads->     Configure(elements, loads, nodes,vertices, materials,parameters);
+	parameters->Configure(elements,loads, nodes,vertices, materials,parameters);
+
+	/*allocate dynamic memory: */
+	eps=(double*)xmalloc(num_criterionenums*sizeof(double));
+
+	/*Go through elements, and ask them to do the job: */
+	for(i=0;i<elements->Size();i++){
+		Element* element=(Element*)elements->GetObjectByOffset(i);
+		element->InputConvergence(&converged,eps,enums,num_enums,criterionenums,criterionvalues,num_criterionenums);
+		if(!converged)break;
+	}
+
+	if(!converged){ 
+		/*get convergence information to user: */
+		if(verbose>2)rank_allowed=my_rank;
+		else rank_allowed=0;
+		if(my_rank==rank_allowed){
+			printf("%s%i%s"," non convergence on element ",element->Id()," for inputs ("); for(i=0;i<num_enums-1;i++)printf("%s,",EnumAsString(enums[i])); printf("%s) ",EnumAsString(enums[num_enums-1]));
+			printf("criterions: "); for(i=0;i<num_criterionenums;i++)printf("%s: %g/%g ",EnumAsString(criterionenums[i]),eps[i],criterionvalues[i]);
+		}
+	}
+	
+	/*In parallel, we need to gather the converged status: */
+	#ifdef _PARALLEL_
+	MPI_Reduce (&converged,&node_converged,1,MPI_INT,MPI_MIN,0,MPI_COMM_WORLD );
+	MPI_Bcast(&node_converged,1,MPI_INT,0,MPI_COMM_WORLD);   
+	converged=node_converged;
+	#endif
+
+	/*Free ressources:*/
+	xfree((void**)&eps);
+
+	/*return: */
+	return converged;
+}
Index: issm/trunk/src/c/modules/InputConvergencex/InputConvergencex.h
===================================================================
--- issm/trunk/src/c/modules/InputConvergencex/InputConvergencex.h	(revision 4055)
+++ issm/trunk/src/c/modules/InputConvergencex/InputConvergencex.h	(revision 4055)
@@ -0,0 +1,13 @@
+/*!\file:  InputConvergencex.h
+ */ 
+
+#ifndef _INPUTCONVERGENCEX_H
+#define _INPUTCONVERGENCEX_H
+
+#include "../../DataSet/DataSet.h"
+
+/* local prototypes: */
+int InputConvergencex(DataSet* elements,DataSet* nodes,DataSet* vertices,DataSet* loads,DataSet* materials,Parameters* parameters,int enums, int num_enums, int criterionenums, double* criterionvalues,int num_criterionenums);
+
+#endif  /* _INPUTCONVERGENCEX_H */
+
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateDataSets.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateDataSets.cpp	(revision 4054)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateDataSets.cpp	(revision 4055)
@@ -57,5 +57,5 @@
 			break;
 
-		case SlopeComputeAnalysisEnum:
+		case SlopeAnalysisEnum:
 			CreateNodesSlopeCompute(pnodes, iomodel,iomodel_handle);
 			CreateConstraintsSlopeCompute(pconstraints,iomodel,iomodel_handle);
Index: issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 4054)
+++ issm/trunk/src/c/modules/ModelProcessorx/CreateParameters.cpp	(revision 4055)
@@ -37,5 +37,4 @@
 	if (iomodel->dim==2) parameters->AddObject(new IntParam(DimEnum,2));
 	else parameters->AddObject(new IntParam(DimEnum,3));
-	parameters->AddObject(new StringParam(OutputFileNameEnum,iomodel->outputfilename));
 	parameters->AddObject(new BoolParam(IsHutterEnum,iomodel->ishutter));
 	parameters->AddObject(new BoolParam(IsMacAyealPattynEnum,iomodel->ismacayealpattyn));
Index: issm/trunk/src/c/modules/ModelProcessorx/SlopeCompute/CreateNodesSlopeCompute.cpp
===================================================================
--- issm/trunk/src/c/modules/ModelProcessorx/SlopeCompute/CreateNodesSlopeCompute.cpp	(revision 4054)
+++ issm/trunk/src/c/modules/ModelProcessorx/SlopeCompute/CreateNodesSlopeCompute.cpp	(revision 4055)
@@ -46,5 +46,5 @@
 			
 			/*Add node to nodes dataset: */
-			nodes->AddObject(new Node(iomodel->nodecounter+i+1,i,iomodel,SlopeComputeAnalysisEnum));
+			nodes->AddObject(new Node(iomodel->nodecounter+i+1,i,iomodel,SlopeAnalysisEnum));
 
 		}
Index: issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp
===================================================================
--- issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 4054)
+++ issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 4055)
@@ -15,9 +15,10 @@
 #include "../../objects/objects.h"
 		
-void OutputResults(DataSet* elements, DataSet* loads, DataSet* nodes, DataSet* vertices, DataSet* materials, Parameters* parameters, char* filename){
+void OutputResults(DataSet* elements, DataSet* loads, DataSet* nodes, DataSet* vertices, DataSet* materials, Parameters* parameters){
 
 	int i;
 
 	Patch* patch=NULL;
+	char*  filename=NULL;
 
 	int solutiontype;
@@ -37,4 +38,5 @@
 	//Recover solutiontype which will be output to disk: 
 	parameters->FindParam(&solutiontype,SolutionTypeEnum);
+	parameters->FindParam(&filename,OutputFileNameEnum);
 
 	//Process results to be output in the correct units
@@ -104,4 +106,5 @@
 	/*Free ressources:*/
 	delete patch;
+	xfree((void**)&filename);
 
 }
Index: issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.h
===================================================================
--- issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.h	(revision 4054)
+++ issm/trunk/src/c/modules/OutputResultsx/OutputResultsx.h	(revision 4055)
@@ -9,5 +9,5 @@
 
 /* local prototypes: */
-void OutputResults(DataSet* elements, DataSet* loads, DataSet* nodes, DataSet* vertices, DataSet* materials, Parameters* parameters, char* filename);
+void OutputResults(DataSet* elements, DataSet* loads, DataSet* nodes, DataSet* vertices, DataSet* materials, Parameters* parameters);
 
 #endif  /* _OUTPUTRESULTS_H */
Index: issm/trunk/src/c/modules/UpdateGeometryx/UpdateGeometryx.cpp
===================================================================
--- issm/trunk/src/c/modules/UpdateGeometryx/UpdateGeometryx.cpp	(revision 4054)
+++ issm/trunk/src/c/modules/UpdateGeometryx/UpdateGeometryx.cpp	(revision 4055)
@@ -11,12 +11,13 @@
 #include "../../DataSet/DataSet.h"
 
-void UpdateGeometryx(Vec* poutthickness,Vec* poutbed,Vec* poutsurface, 
-		DataSet* elements, DataSet* nodes, DataSet* vertices,DataSet* loads, DataSet* materials, Parameters* parameters,
-		Vec vec_newthickness,Vec vec_bed,Vec vec_surface){
+void UpdateGeometryx( DataSet* elements, DataSet* nodes, DataSet* vertices,DataSet* loads, DataSet* materials, Parameters* parameters){
 
 	int i;
 	int dof;
 
-	/*serialized input: */
+	/*vectorized inputs: */
+	Vec     vec_newthickness=NULL;
+	Vec     vec_bed=NULL;
+	Vec     vec_surface=NULL:
 	double* newthickness=NULL;
 	double* bed=NULL;
@@ -24,5 +25,5 @@
 
 	/*objects: */
-	Node* node=NULL;
+	Vertex* vertex=NULL;
 	Object* object=NULL;
 	Matpar* matpar=NULL;
@@ -31,14 +32,4 @@
 	double h,b,s;
 	double rho_ice,rho_water;
-
-	/*output: */
-	Vec outthickness=NULL;
-	Vec outbed=NULL;
-	Vec outsurface=NULL;
-
-	/*Duplicate inputs to outputs, do not copy values!: */
-	VecDuplicate(vec_newthickness,&outthickness);
-	VecDuplicate(vec_bed,&outbed);
-	VecDuplicate(vec_surface,&outsurface);
 
 	/*First, get elements and loads configured: */
@@ -49,5 +40,9 @@
 	parameters->Configure(elements,loads, nodes,vertices, materials,parameters);
 
-	/*Serialize inputs :*/
+	/*retrieve inputs: */
+	GetVectorFromInputsx( &vec_newthickness, elements, nodes,  vertices,  loads,  materials,  parameters, ThicknessEnum,VertexEnum);
+	GetVectorFromInputsx( &vec_bed, elements, nodes,  vertices,  loads,  materials,  parameters, ThicknessEnum,VertexEnum);
+	GetVectorFromInputsx( &vec_surface, elements, nodes,  vertices,  loads,  materials,  parameters, ThicknessEnum,VertexEnum);
+
 	VecToMPISerial(&newthickness,vec_newthickness);
 	VecToMPISerial(&bed,vec_bed);
@@ -67,14 +62,14 @@
 	rho_water=matpar->GetRhoWater();
 
-	/*Go through nodes and for each node, update the thickness, bed and surface, using the 
+	/*Go through vertices and for each vertex, update the thickness, bed and surface, using the 
 	 * new thickness computed in the prognostic_core part of the transient solution sequence: */
 
-	for(i=0;i<nodes->Size();i++){
+	for(i=0;i<vertices->Size();i++){
 
 		/*get i'th node: */
-		node=(Node*)nodes->GetObjectByOffset(i);
+		vertex=(Vertex*)vertices->GetObjectByOffset(i);
 
-		/*first, recover thickness, surface and bed for this node: */
-		dof=node->GetDofList1();
+		/*first, recover thickness, surface and bed for this vertex: */
+		dof=vertex->GetDofList1();
 		h=newthickness[dof];
 		s=surface[dof];
@@ -85,10 +80,10 @@
 
 		//For grids on ice sheet, the new bed remains the same, the new surface becomes bed+new_thickness. 
-		if (node->IsOnSheet()){
+		if (vertex->IsOnSheet()){
 			s=b+h;
 		}
 
 		//For grids on ice shelt, we have hydrostatic equilibrium (for now)
-		if (node->IsOnShelf()){
+		if (vertex->IsOnShelf()){
 			b=-rho_ice/rho_water*h;
 			s=(1-rho_ice/rho_water)*h;
@@ -96,27 +91,31 @@
 
 		/*Ok, plug values of thickness, surafce and bed into our outputs: */
-		VecSetValues(outthickness,1,&dof,&h,INSERT_VALUES);
-		VecSetValues(outbed,1,&dof,&b,INSERT_VALUES);
-		VecSetValues(outsurface,1,&dof,&s,INSERT_VALUES);
+		VecSetValues(vec_newthickness,1,&dof,&h,INSERT_VALUES);
+		VecSetValues(vec_bed,1,&dof,&b,INSERT_VALUES);
+		VecSetValues(vec_surface,1,&dof,&s,INSERT_VALUES);
 	}
 
 	/*Assemble vectors: */
-	VecAssemblyBegin(outthickness);
-	VecAssemblyEnd(outthickness);
+	VecAssemblyBegin(vec_newthickness);
+	VecAssemblyEnd(vec_newthickness);
 
-	VecAssemblyBegin(outbed);
-	VecAssemblyEnd(outbed);
+	VecAssemblyBegin(vec_bed);
+	VecAssemblyEnd(vec_bed);
 
-	VecAssemblyBegin(outsurface);
-	VecAssemblyEnd(outsurface);
+	VecAssemblyBegin(vec_surface);
+	VecAssemblyEnd(vec_surface);
+
+	/*Put back into inputs:*/
+	UpdateInputsFromVectorx( elements,nodes, vertices,loads, materials,  parameters,vec_newthickness,ThicknessEnum,VertexEnum); //clobber existing thickness input with new one
+	UpdateInputsFromVectorx( elements,nodes, vertices,loads, materials,  parameters,vec_bed,BedEnum,VertexEnum); 
+	UpdateInputsFromVectorx( elements,nodes, vertices,loads, materials,  parameters,vec_surface,SurfaceEnum,VertexEnum); 
 
 	/*Free ressources:*/
+	VecFree(&vec_newthickness);
+	VecFree(&vec_bed);
+	VecFree(&vec_surface);
 	xfree((void**)&newthickness);
 	xfree((void**)&bed);
 	xfree((void**)&surface);
 	
-	/*Assign output pointers: */
-	*poutthickness=outthickness;
-	*poutbed=outbed;
-	*poutsurface=outsurface;
 }
Index: issm/trunk/src/c/modules/UpdateGeometryx/UpdateGeometryx.h
===================================================================
--- issm/trunk/src/c/modules/UpdateGeometryx/UpdateGeometryx.h	(revision 4054)
+++ issm/trunk/src/c/modules/UpdateGeometryx/UpdateGeometryx.h	(revision 4055)
@@ -10,7 +10,5 @@
 
 /* local prototypes: */
-void UpdateGeometryx(Vec* poutthickness,Vec* poutbed,Vec* poutsurface, 
-		DataSet* elements, DataSet* nodes,DataSet* vertices,DataSet* loads, DataSet* materials, Parameters* parameters,
-		Vec newthickness,Vec bed,Vec surface);
+void UpdateGeometryx(DataSet* elements, DataSet* nodes,DataSet* vertices,DataSet* loads, DataSet* materials, Parameters* parameters);
 
 #endif  /* _UPDATEGEOMETRYX_H */
